import type { IServiceCollection } from "../interfaces/IServiceCollection.js";
import type { IServiceConstructor } from "../interfaces/IServiceConstructor.js";
import type { IServiceDescriptor } from "../interfaces/IServiceDescriptor.js";
import type { IServiceFactory } from "../interfaces/IServiceFactory.js";
import type { ServiceImplementation } from "../interfaces/ServiceImplementation.js";
import type { ServiceType } from "../interfaces/ServiceType.js";
import type { IAsyncServiceImplementationLoader } from "../interfaces/IAsyncServiceImplementationLoader.js";
export declare class ServiceCollection implements IServiceCollection {
    protected readonly collection: Map<any, IServiceDescriptor<unknown>[]>;
    constructor(collection?: ServiceCollection);
    [Symbol.iterator](): Iterator<IServiceDescriptor<unknown>, any, undefined>;
    getDescriptors<T>(service: ServiceType<T>): IServiceDescriptor<T>[];
    addScoped<T>(service: ServiceImplementation<T>): this;
    addScoped<T>(service: ServiceType<T>, factory: IServiceFactory<T> | IAsyncServiceImplementationLoader<IServiceFactory<T>>): this;
    addScoped<T>(service: ServiceType<T>, constructor: IServiceConstructor<T> | IAsyncServiceImplementationLoader<IServiceConstructor<T>>): this;
    addTransient<T>(service: ServiceImplementation<T>): this;
    addTransient<T>(service: ServiceType<T>, factory: IServiceFactory<T> | IAsyncServiceImplementationLoader<IServiceFactory<T>>): this;
    addTransient<T>(service: ServiceType<T>, constructor: IServiceConstructor<T> | IAsyncServiceImplementationLoader<IServiceConstructor<T>>): this;
    addSingleton<T>(service: ServiceImplementation<T>): this;
    addSingleton<T>(service: ServiceType<T>, implementation: T | IAsyncServiceImplementationLoader<T>): this;
    addSingleton<T>(service: ServiceType<T>, factory: IServiceFactory<T> | IAsyncServiceImplementationLoader<IServiceFactory<T>>): this;
    addSingleton<T>(service: ServiceType<T>, constructor: IServiceConstructor<T> | IAsyncServiceImplementationLoader<IServiceConstructor<T>>): this;
    protected copy(): Iterable<[any, IServiceDescriptor<unknown>[]]>;
    private addService;
}
//# sourceMappingURL=ServiceCollection.d.ts.map