import type { IAsyncServiceScope } from "../interfaces/IAsyncServiceScope.js";
import { IServiceProvider } from "./IServiceProvider.js";
import type { IServiceScope } from "../interfaces/IServiceScope.js";
import { ServiceCollection } from "./ServiceCollection.js";
import type { ServiceType } from "../interfaces/ServiceType.js";
export declare class ServiceProvider implements IServiceProvider {
    private readonly collection;
    private readonly parent?;
    private readonly instancesStore;
    constructor(collection: ServiceCollection, parent?: IServiceProvider | undefined);
    getServices<T>(service: ServiceType<T>): T[];
    getServiceAsync<T>(service: ServiceType<T>): Promise<T>;
    getService<T>(service: ServiceType<T>): T;
    getServicesAsync<T>(service: ServiceType<T>): Promise<T[]>;
    createScope(): IServiceScope;
    createAsyncScope(): IAsyncServiceScope;
    private internalGetServices;
    private internalGetService;
    private internalGetDescriptorImplementation;
    private createInstanceFromDescriptor;
    private initializeService;
    private getDescriptor;
    private resolveGeneratorSync;
    private resolveGeneratorAsync;
    [Symbol.dispose](): void;
    [Symbol.asyncDispose](): Promise<void>;
}
//# sourceMappingURL=ServiceProvider.d.ts.map